diff --git a/src/backend/catalog/partition.c b/src/backend/catalog/partition.c
index 5e238dc..46bbb9e 100644
--- a/src/backend/catalog/partition.c
+++ b/src/backend/catalog/partition.c
@@ -449,3 +534,1449 @@ FreePartitionKey(PartitionKey key)
 	free_key_type_coll_info(key->tcinfo);
 	pfree(key);
 }
+
+/*
+ * StorePartitionBound
+ *
+ * Store partition boundary info in pg_partition after checking for its
+ * validity.
+ */
+void
+StorePartitionBound(Oid relid, Oid parentId, Node *bound)
+{
+	Relation		pg_partition;
+	Relation		parent;
+	PartitionKey	key;
+	PartitionDesc	pdesc;
+	Oid				with;
+	HeapTuple		tuple;
+	char		   *boundString;
+	Datum			values[Natts_pg_partition];
+	bool			nulls[Natts_pg_partition];
+	ParseState	   *pstate = make_parsestate(NULL);
+
+	parent = heap_open(parentId, AccessShareLock);
+	key = parent->rd_partkey;
+	pdesc = RelationGetPartitionDesc(parent);
+
+	/*
+	 * Check if 'bound' happens to overlap with any of parent's existing
+	 * partitions.
+	 */
+	switch (key->strategy)
+	{
+		case PARTITION_STRAT_LIST:
+		{
+			PartitionListSpec *list;
+
+			Assert(IsA(bound, PartitionListSpec));
+			list = (PartitionListSpec *) bound;
+			if (list_overlaps_existing_partition(key, list, pdesc, &with))
+				ereport(ERROR,
+					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+					 errmsg("new partition's list of values overlaps with that"
+							" of partition \"%s\" of \"%s\"",
+							get_rel_name(with),	get_rel_name(parentId)),
+					 errhint("Please specify a list of values that does not"
+							 " overlap with any existing list partition's list."),
+					 parser_errposition(pstate, list->location)));
+			break;
+		}
+
+		case PARTITION_STRAT_RANGE:
+		{
+			PartitionRangeSpec *range;
+
+			Assert(IsA(bound, PartitionRangeSpec));
+			range = (PartitionRangeSpec *) bound;
+			if (partition_range_empty(key, range))
+				ereport(ERROR,
+					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+					 errmsg("new partition's range contains no element"),
+					 errhint("Please specify a non-empty range."),
+					 parser_errposition(pstate, range->location)));
+
+			if (range_overlaps_existing_partition(key, range, pdesc, &with))
+				ereport(ERROR,
+						(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+						 errmsg("new partition's range overlaps with that of"
+								" partition \"%s\" of \"%s\"",
+								get_rel_name(with),	get_rel_name(parentId)),
+						 errhint("Please specify a range that does not overlap"
+								 " with any existing partition's range."),
+						 parser_errposition(pstate, range->location)));
+			break;
+		}
+	}
+
+	pg_partition = heap_open(PartitionRelationId, RowExclusiveLock);
+
+	boundString = nodeToString(bound);
+
+	/* Build the tuple - bound can never be null */
+	MemSet(nulls, false, sizeof(nulls));
+
+	values[Anum_pg_partition_partrelid - 1] = ObjectIdGetDatum(relid);
+	values[Anum_pg_partition_partbound - 1] = CStringGetTextDatum(boundString);
+
+	tuple = heap_form_tuple(RelationGetDescr(pg_partition), values, nulls);
+
+	simple_heap_insert(pg_partition, tuple);
+
+	/* Update the indexes on pg_partition */
+	CatalogUpdateIndexes(pg_partition, tuple);
+
+	/*
+	 * Invalid the parent's relcache so that the partition is now included in
+	 * its partition descriptor.
+	 */
+	CacheInvalidateRelcache(parent);
+
+	heap_close(parent, AccessShareLock);
+	heap_close(pg_partition, RowExclusiveLock);
+}
+
+/*
+ * Does new list partition 'bound' overlap any of existing list partitions?
+ */
+static bool
+list_overlaps_existing_partition(PartitionKey key,
+								 PartitionListSpec *list_spec,
+								 PartitionDesc pdesc,
+								 Oid *with)
+{
+	PartitionListBound *new_list;
+	int			i;
+
+	if (pdesc->nparts == 0)
+		return false;
+
+	new_list = make_list_from_spec(key, list_spec->values);
+
+	for (i = 0; i < pdesc->nparts; i++)
+	{
+		int		j;
+
+		if (pdesc->lists[i]->contains_null && new_list->contains_null)
+			return true;
+
+		for (j = 0; j < pdesc->lists[i]->nvalues; j++)
+		{
+			int		k;
+
+			for (k = 0; k < new_list->nvalues; k++)
+			{
+				int32	result;
+
+				result = DatumGetInt32(FunctionCall2Coll(&key->partsupfunc[0],
+										  key->tcinfo->typcoll[0],
+										  pdesc->lists[i]->values[j],
+										  new_list->values[k]));
+				if (!result)
+				{
+					*with = pdesc->oids[i];
+					return true;
+				}
+			}
+		}
+	}
+
+	return false;
+}
+
+/*
+ * Is new partition's range empty?
+ */
+static bool
+partition_range_empty(PartitionKey key, PartitionRangeSpec *range_spec)
+{
+	PartitionRangeBound *lower,
+						*upper;
+
+	lower = make_range_from_spec(key, range_spec->lower, range_spec->lowerinc,
+								 true);
+	upper = make_range_from_spec(key, range_spec->upper, range_spec->upperinc,
+								 false);
+
+	/*
+	 * Only either lower or upper is allowed to be unbounded, which if
+	 * one of them is, the range is not empty.
+	 */
+	if (lower->infinite || upper->infinite)
+		return false;
+
+	/*
+	 * If upper > lower, ouright empty or if lower = upper and either of
+	 * them is exclusive.
+	 */
+	if (compare_range_keys(key, upper->val, lower->val) < 0 ||
+		(compare_range_keys(key, lower->val, upper->val) == 0 &&
+		 (!lower->inclusive || !upper->inclusive)))
+		return true;
+
+	return false;
+}
+
+/* Compare range composite keys using logic similar to RowCompareExpr */
+static int32
+compare_range_keys(PartitionKey key, Datum *val1, Datum *val2)
+{
+	int32	result;
+	int		i;
+
+	for (i = 0; i < key->partnatts; i++)
+	{
+		result = DatumGetInt32(FunctionCall2Coll(&key->partsupfunc[i],
+											 key->tcinfo->typcoll[i],
+											 val1[i], val2[i]));
+		if (!result)
+			continue;
+		break;
+	}
+
+	return result;
+}
+
+/*
+ * Does new range partition's range overlap any of existing range partitions?
+ */
+static bool
+range_overlaps_existing_partition(PartitionKey key,
+								  PartitionRangeSpec *range_spec,
+								  PartitionDesc pdesc,
+								  Oid *with)
+{
+	int		i;
+	PartitionRangeBound *new_lower,
+						*new_upper;
+
+	if (pdesc->nparts == 0)
+		return false;
+
+	/*
+	 * Create internal representation of rangelower and rangeupper from
+	 * range_spec.
+	 */
+	new_lower = make_range_from_spec(key, range_spec->lower, range_spec->lowerinc,
+									 true);
+	new_upper = make_range_from_spec(key, range_spec->upper, range_spec->upperinc,
+									 false);
+
+	/* Check with existing partitions for overlap */
+	for (i = 0; i < pdesc->nparts; i++)
+	{
+		if (partition_range_overlaps(key, new_lower, new_upper,
+									 pdesc->rangelowers[i],
+									 pdesc->rangeuppers[i]))
+		{
+			*with = pdesc->oids[i];
+			return true;
+		}
+	}
+
+	return false;
+}
+
+/*
+ * Make a PartitionListBound from list of values using the information in key
+ */
+static PartitionListBound *
+make_list_from_spec(PartitionKey key, List *values)
+{
+	PartitionListBound *list;
+	ListCell   *cell;
+	int			i;
+
+	list = (PartitionListBound *) palloc0(sizeof(PartitionListBound));
+	list->nvalues = list_length(values);
+	list->values = (Datum *) palloc(list->nvalues * sizeof(Datum));
+
+	i = 0;
+	foreach (cell, values)
+	{
+		Const	*val = lfirst(cell);
+
+		if (val->constisnull)
+			list->contains_null = true;
+		else
+			list->values[i] = datumCopy(val->constvalue,
+										key->tcinfo->typbyval[0],
+										key->tcinfo->typlen[0]);
+		i++;
+	}
+
+	return list;
+}
+
+/*
+ * Make a PartitionRangeBound from arguments using the information in key
+ */
+static PartitionRangeBound *
+make_range_from_spec(PartitionKey key, List *val, bool inclusive, bool lower)
+{
+	PartitionRangeBound *range;
+	ListCell *cell;
+
+	range = (PartitionRangeBound *) palloc0(sizeof(PartitionRangeBound));
+	range->infinite = (val == NIL);
+	range->inclusive = inclusive;
+	range->lower = lower;
+
+	if (val)
+	{
+		int		i;
+
+		range->val = (Datum *) palloc0(key->partnatts * sizeof(Datum));
+
+		i = 0;
+		foreach (cell, val)
+		{
+			Const *val = lfirst(cell);
+
+			if (val->constisnull)
+				ereport(ERROR,
+					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+					 errmsg("cannot specify NULL in range bound")));
+			else
+				range->val[i] = datumCopy(val->constvalue,
+										  key->tcinfo->typbyval[i],
+										  key->tcinfo->typlen[i]);
+			i++;
+		}
+	}
+
+	return range;
+}
+
+/* Check two range partitions for overlap */
+static bool
+partition_range_overlaps(PartitionKey key,
+			   PartitionRangeBound *part1_lower,
+			   PartitionRangeBound *part1_upper,
+			   PartitionRangeBound *part2_lower,
+			   PartitionRangeBound *part2_upper)
+{
+	if (partition_range_cmp_bounds(key, part1_lower, part2_lower) >= 0 &&
+		partition_range_cmp_bounds(key, part1_lower, part2_upper) <= 0)
+		return true;
+
+	if (partition_range_cmp_bounds(key, part2_lower, part1_lower) >= 0 &&
+		partition_range_cmp_bounds(key, part2_lower, part1_upper) <= 0)
+		return true;
+
+	return false;
+}
+
+/* Returns for two range partition bounds whether, b1 <=, =, >= b2 */
+static int32
+partition_range_cmp_bounds(PartitionKey key,
+						   PartitionRangeBound *b1,
+						   PartitionRangeBound *b2)
+{
+	int32		result;
+
+	/*
+	 * First, handle cases involving infinity, which don't require invoking
+	 * the comparison proc.
+	 */
+	if (b1->infinite && b2->infinite)
+	{
+		/*
+		 * Both are infinity, so they are equal unless one is lower and the
+		 * other not.
+		 */
+		if (b1->lower == b2->lower)
+			return 0;
+		else
+			return b1->lower ? -1 : 1;
+	}
+	else if (b1->infinite)
+		return b1->lower ? -1 : 1;
+	else if (b2->infinite)
+		return b2->lower ? 1 : -1;
+
+	/*
+	 * Both boundaries are finite, so compare the held values.
+	 */
+	result = compare_range_keys(key, b1->val, b2->val);
+
+	/*
+	 * If the comparison is anything other than equal, we're done. If they
+	 * compare equal though, we still have to consider whether the boundaries
+	 * are inclusive or exclusive.
+	 */
+	if (result == 0)
+	{
+		if (!b1->inclusive && !b2->inclusive)
+		{
+			/* both are exclusive */
+			if (b1->lower == b2->lower)
+				return 0;
+			else
+				return b1->lower ? 1 : -1;
+		}
+		else if (!b1->inclusive)
+			return b1->lower ? 1 : -1;
+		else if (!b2->inclusive)
+			return b2->lower ? -1 : 1;
+		else
+		{
+			/*
+			 * Both are inclusive and the values held are equal, so they are
+			 * equal regardless of whether they are upper or lower boundaries,
+			 * or a mix.
+			 */
+			return 0;
+		}
+	}
+
+	return result;
+}
+
+/*
+ *  RemovePartitionByRelId
+ *		Remove a pg_partition entry for a partition.
+ */
+void
+RemovePartitionEntryByRelId(Oid relid)
+{
+	Relation		rel;
+	HeapTuple		tuple;
+
+	rel = heap_open(PartitionRelationId, RowExclusiveLock);
+	tuple = SearchSysCache1(PARTRELID, ObjectIdGetDatum(relid));
+
+	if (!HeapTupleIsValid(tuple))
+		elog(ERROR, "cache lookup failed for partition entry of relation %u",
+					 relid);
+
+	simple_heap_delete(rel, &tuple->t_self);
+
+	/* Update the indexes on pg_partitioned_rel */
+	CatalogUpdateIndexes(rel, tuple);
+
+	ReleaseSysCache(tuple);
+	heap_close(rel, RowExclusiveLock);
+}
+
+/*
+ * does relid have pg_partition entry?
+ */
+bool
+relid_is_partition(Oid relid)
+{
+	return SearchSysCacheExists1(PARTRELID, ObjectIdGetDatum(relid));
+}
+
+/*
+ * Returns inheritance parent of relid by scanning pg_inherits
+ */
+Oid
+get_partition_parent(Oid relid)
+{
+	Form_pg_inherits form;
+	Relation	catalogRelation;
+	SysScanDesc scan;
+	ScanKeyData key[2];
+	HeapTuple	tuple;
+
+	catalogRelation = heap_open(InheritsRelationId, AccessShareLock);
+
+	ScanKeyInit(&key[0],
+				Anum_pg_inherits_inhrelid,
+				BTEqualStrategyNumber, F_OIDEQ,
+				ObjectIdGetDatum(relid));
+	ScanKeyInit(&key[1],
+				Anum_pg_inherits_inhseqno,
+				BTEqualStrategyNumber, F_INT4EQ,
+				Int32GetDatum(1));
+
+	scan = systable_beginscan(catalogRelation, InheritsRelidSeqnoIndexId, true,
+							  NULL, 2, key);
+
+	tuple = systable_getnext(scan);
+	Assert(HeapTupleIsValid(tuple));
+
+	form = (Form_pg_inherits) GETSTRUCT(tuple);
+
+	systable_endscan(scan);
+	heap_close(catalogRelation, AccessShareLock);
+
+	return form->inhparent;
+}
+
+/*
+ * RelationDropPartitions
+ *		Find and drop all partitions of relation with OID 'relid'
+ */
+void
+RelationDropPartitions(Oid relid)
+{
+	List	   *partitionOids;
+	ListCell   *cell;
+
+	partitionOids = get_partitions(relid, AccessExclusiveLock);
+
+	foreach (cell, partitionOids)
+	{
+		Oid		partitionOid = lfirst_oid(cell);
+		ObjectAddress	obj;
+
+		obj.classId = RelationRelationId;
+		obj.objectId = partitionOid;
+		obj.objectSubId = 0;
+
+		performDeletion(&obj, DROP_CASCADE, 0);
+	}
+}
+
+/*
+ * RelationGetPartitionDesc
+ *		Get the PartitionDesc of a partitioned table
+ *
+ * Memory for the struct is allocated in the caller's memory context while
+ * a copy is cached in rd_partdesc so that we don't compute the result
+ * unnecessarily (We don't want to return a pointer to the relcache copy
+ * though, since it could disappear due to relcache invalidation.)
+ *
+ * Never returns NULL.  If there are no partitions yet, returns the struct
+ * with nparts set to 0.
+ */
+static PartitionDesc
+RelationGetPartitionDesc(Relation relation)
+{
+	int				i,
+					nparts;
+	PartitionKey	key = relation->rd_partkey;
+	MemoryContext	oldcxt;
+	PartitionDesc	result;
+	PartitionInfo **parts;
+
+	/* Quick copy and exit if already computed the descriptor */
+	if (relation->rd_partdesc != NULL)
+		return GetPartitionDescCopy(key, relation->rd_partdesc);
+
+	result = (PartitionDesc) palloc0(sizeof(PartitionDescData));
+
+	parts = GetRelPartitions(relation, &nparts);
+	result->nparts = nparts;
+
+	if (parts)
+	{
+		result->oids = (Oid *) palloc0(nparts * sizeof(Oid));
+
+		switch (key->strategy)
+		{
+			case PARTITION_STRAT_LIST:
+				result->lists = (PartitionListBound **) palloc0(nparts *
+												sizeof(PartitionListBound *));
+				break;
+
+			case PARTITION_STRAT_RANGE:
+				result->rangelowers = (PartitionRangeBound **) palloc0(nparts *
+												sizeof(PartitionRangeBound *));
+				result->rangeuppers = (PartitionRangeBound **) palloc0(nparts *
+												sizeof(PartitionRangeBound *));
+
+				/* Sort on range->upper */
+				qsort_arg(parts, nparts, sizeof(PartitionInfo *),
+						  range_partition_cmp_upper, key);
+				break;
+		}
+
+		for (i = 0; i < nparts; i++)
+		{
+			result->oids[i] = parts[i]->oid;
+
+			if (parts[i]->list)
+				result->lists[i] = copyPartitionListBound(parts[i]->list, key);
+			else
+			{
+				result->rangelowers[i] = copyPartitionRangeBound(parts[i]->rangelower, key);
+				result->rangeuppers[i] = copyPartitionRangeBound(parts[i]->rangeupper, key);
+			}
+		}
+
+		/* Clean up */
+		free_partition_info_array(parts, nparts);
+	}
+
+	/* Save a copy in the relcache */
+	relation->rd_pdcxt = AllocSetContextCreate(CacheMemoryContext,
+										RelationGetRelationName(relation),
+										ALLOCSET_DEFAULT_MINSIZE,
+										ALLOCSET_DEFAULT_INITSIZE,
+										ALLOCSET_DEFAULT_MAXSIZE);
+
+	relation->rd_partdesc = MemoryContextAllocZero(relation->rd_pdcxt,
+													sizeof(PartitionDescData));
+	oldcxt = MemoryContextSwitchTo(relation->rd_pdcxt);
+	relation->rd_partdesc = GetPartitionDescCopy(key, result);
+	MemoryContextSwitchTo(oldcxt);
+
+	return result;
+}
+
+/*
+ * GetPartitionDescCopy
+ *		Copy PartitionDesc of a partitioned relation into caller's context
+ *
+ * Like its caller, never returns NULL.
+ */
+static PartitionDesc
+GetPartitionDescCopy(PartitionKey key, PartitionDesc src)
+{
+	PartitionDesc	result;
+	int				i;
+
+	result = (PartitionDesc) palloc0(sizeof(PartitionDescData));
+	result->nparts = src->nparts;
+
+	/* If there are partitions, actually copy partitions */
+	if (src->nparts > 0)
+	{
+		result->oids = (Oid *) palloc0(result->nparts * sizeof(Oid));
+
+		switch (key->strategy)
+		{
+			case PARTITION_STRAT_LIST:
+				result->lists = (PartitionListBound **) palloc0(src->nparts *
+												sizeof(PartitionListBound *));
+				break;
+
+			case PARTITION_STRAT_RANGE:
+				result->rangelowers = (PartitionRangeBound **) palloc0(src->nparts *
+												sizeof(PartitionRangeBound *));
+				result->rangeuppers = (PartitionRangeBound **) palloc0(src->nparts *
+												sizeof(PartitionRangeBound *));
+				break;
+		}
+
+		for (i = 0; i < src->nparts; i++)
+		{
+			result->oids[i] = src->oids[i];
+
+			switch (key->strategy)
+			{
+				case PARTITION_STRAT_LIST:
+					result->lists[i] = copyPartitionListBound(src->lists[i], key);
+					break;
+
+				case PARTITION_STRAT_RANGE:
+					result->rangelowers[i] = copyPartitionRangeBound(src->rangelowers[i], key);
+					result->rangeuppers[i] = copyPartitionRangeBound(src->rangeuppers[i], key);
+					break;
+			}
+		}
+	}
+
+	return result;
+}
+
+/*
+ * GetRelPartitions
+ *		Return information of partitions of rel
+ *
+ * Returns number of partitions in *nparts.
+ */
+static PartitionInfo **
+GetRelPartitions(Relation rel, int *nparts)
+{
+	int				i;
+	Relation		partrel;
+	List		   *partoids;
+	ListCell	   *cell;
+	PartitionInfo **parts;
+	PartitionKey	key = rel->rd_partkey;
+
+	partoids = get_partitions(RelationGetRelid(rel), NoLock);
+
+	/* no partitions found */
+	if ((*nparts = list_length(partoids)) == 0)
+		return NULL;
+
+	partrel = heap_open(PartitionRelationId, AccessShareLock);
+
+	parts = (PartitionInfo **) palloc0(*nparts * sizeof(PartitionInfo *));
+
+	i = 0;
+	foreach(cell, partoids)
+	{
+		Oid 		partrelid = lfirst_oid(cell);
+		HeapTuple	tuple;
+		Datum		datum;
+		bool		isnull;
+		Node	   *bound;
+
+		tuple = SearchSysCache1(PARTRELID, partrelid);
+		Assert(HeapTupleIsValid(tuple));
+
+		parts[i] = (PartitionInfo *) palloc0(sizeof(PartitionInfo));
+		parts[i]->oid = partrelid;
+
+		datum = fastgetattr(tuple,
+							Anum_pg_partition_partbound,
+							partrel->rd_att,
+							&isnull);
+
+		bound = stringToNode(TextDatumGetCString(datum));
+
+		switch (key->strategy)
+		{
+			case PARTITION_STRAT_LIST:
+			{
+				PartitionListSpec  *list_spec;
+
+				Assert(IsA(bound, PartitionListSpec));
+				list_spec = (PartitionListSpec *) bound;
+				parts[i]->list = make_list_from_spec(key, list_spec->values);
+			}
+			break;
+
+			case PARTITION_STRAT_RANGE:
+			{
+				PartitionRangeSpec *range_spec;
+
+				Assert(IsA(bound, PartitionRangeSpec));
+				range_spec = (PartitionRangeSpec *) bound;
+
+				parts[i]->rangelower = make_range_from_spec(key,
+														range_spec->lower,
+														range_spec->lowerinc,
+														true);
+				parts[i]->rangeupper = make_range_from_spec(key,
+														range_spec->upper,
+														range_spec->upperinc,
+														false);
+			}
+			break;
+		}
+
+		ReleaseSysCache(tuple);
+		i++;
+	}
+
+	heap_close(partrel, AccessShareLock);
+
+	return parts;
+}
+
+/*
+ * Wrapper around find_inheritance_children for use by partitioning
+ * related code
+ */
+static List *
+get_partitions(Oid relid, int lockmode)
+{
+	return find_inheritance_children(relid, lockmode);
+}
+
+/*
+ * range_partition_cmp_upper
+ *		Compare two range partition PartitionInfos using their rangeupper
+ *		bounds
+ *
+ * Used as a callback to qsort_arg for sorting range partitions.
+ */
+static int32
+range_partition_cmp_upper(const void *a, const void *b, void *arg)
+{
+	PartitionRangeBound *b1 = (*(const PartitionInfo **) a)->rangeupper,
+						*b2 = (*(const PartitionInfo **) b)->rangeupper;
+
+	if (b1->infinite || b2->infinite)
+		return b1->infinite ? 1 : -1;
+
+	return compare_range_keys((PartitionKey) arg, b1->val, b2->val);
+}
+
+/*
+ * Helper routine to copy a list partition bound struct
+ */
+static PartitionListBound *
+copyPartitionListBound(PartitionListBound *src, PartitionKey key)
+{
+	int				i;
+	PartitionListBound  *result;
+
+	result = (PartitionListBound *) palloc0(sizeof(PartitionListBound));
+	result->nvalues = src->nvalues;
+	result->contains_null = src->contains_null;
+	result->values = (Datum *) palloc0(src->nvalues * sizeof(Datum));
+
+	for (i = 0; i < src->nvalues; i++)
+		result->values[i] = datumCopy(src->values[i],
+									  key->tcinfo->typbyval[0],
+									  key->tcinfo->typlen[0]);
+	return result;
+}
+
+/*
+ * Helper routine to copy a range partition bound struct
+ */
+static PartitionRangeBound *
+copyPartitionRangeBound(PartitionRangeBound *src, PartitionKey key)
+{
+	int				i;
+	PartitionRangeBound  *result;
+
+	result = (PartitionRangeBound *) palloc0(sizeof(PartitionRangeBound));
+	result->infinite = src->infinite;
+	result->inclusive = src->inclusive;
+	result->lower = src->lower;
+
+	if (src->val)
+	{
+		result->val = (Datum *) palloc0(key->partnatts * sizeof(Datum));
+		for (i = 0; i < key->partnatts; i++)
+			result->val[i] = datumCopy(src->val[i],
+										 key->tcinfo->typbyval[i],
+										 key->tcinfo->typlen[i]);
+	}
+
+	return result;
+}
+
+/*
+ * Helper routine to deep-free a PartitionInfo array
+ */
+static void
+free_partition_info_array(PartitionInfo **p, int num)
+{
+	int	i;
+
+	for (i = 0; i < num; i++)
+	{
+		if (p[i]->list)
+		{
+			pfree(p[i]->list->values);
+			pfree(p[i]->list);
+		}
+
+		if (p[i]->rangelower)
+		{
+			if (p[i]->rangelower->val)
+				pfree(p[i]->rangelower->val);
+			pfree(p[i]->rangelower);
+		}
+
+		if (p[i]->rangeupper)
+		{
+			if (p[i]->rangeupper->val)
+				pfree(p[i]->rangeupper->val);
+			pfree(p[i]->rangeupper);
+		}
+
+		pfree(p[i]);
+	}
+
+	pfree(p);
+}
+
+/*
+ * get_check_expr_from_partbound - for direct use by tablecmds.c
+ */
+Expr *
+get_check_expr_from_partbound(Relation rel, Relation parent, Node *bound)
+{
+	PartitionKey key = parent->rd_partkey;
+	Expr   *my_expr;
+	int		i;
+	ListCell *partexprs_item;
+
+	if (IsA(bound, PartitionListSpec))
+	{
+		PartitionListSpec *list_spec = (PartitionListSpec *) bound;
+
+		my_expr = get_check_expr_for_list(key, list_spec->values);
+	}
+	else if (IsA(bound, PartitionRangeSpec))
+	{
+		PartitionRangeSpec *range_spec = (PartitionRangeSpec *) bound;
+
+		my_expr = get_check_expr_for_range(key,
+										   range_spec->lower,
+										   range_spec->lowerinc,
+										   range_spec->upper,
+										   range_spec->upperinc);
+	}
+
+	/*
+	 * Translate vars in the generated expression with the correct attnos.
+	 * Note that the vars in my_expr bear attnos dictated by key which carries
+	 * attnos of the parent.
+	 */
+	partexprs_item = list_head(key->partexprs);
+	for (i = 0; i < key->partnatts; i++)
+	{
+		AttrNumber	attno = key->partattrs[i],
+					new_attno;
+		char	   *attname;
+
+		if (attno != 0)
+		{
+			attname = get_attname(RelationGetRelid(parent), attno);
+			new_attno = get_attnum(RelationGetRelid(rel), attname);
+
+			my_expr = (Expr *) translate_var_attno((Node *) my_expr,
+												   attno,
+												   new_attno);
+		}
+		else
+		{
+			Node *expr = (Node *) lfirst(partexprs_item);
+			Bitmapset  *expr_attrs = NULL;
+			int			index;
+
+			pull_varattnos(expr, 1, &expr_attrs);
+			partexprs_item = lnext(partexprs_item);
+
+			index = -1;
+			while ((index = bms_next_member(expr_attrs, index)) > 0)
+			{
+				AttrNumber attno = index + FirstLowInvalidHeapAttributeNumber;
+				attname = get_attname(RelationGetRelid(parent), attno);
+				new_attno = get_attnum(RelationGetRelid(rel), attname);
+				my_expr = (Expr *) translate_var_attno((Node *) my_expr,
+													   attno,
+													   new_attno);
+			}
+		}
+	}
+
+	return my_expr;
+}
+
+/*
+ * get_check_expr_for_list
+ */
+static Expr *
+get_check_expr_for_list(PartitionKey key, List *values)
+{
+	ArrayExpr		   *values_arr = makeNode(ArrayExpr);
+	ScalarArrayOpExpr  *arrayop_expr;
+	Node   *key_col;
+	Oid		operoid;
+	StrategyNumber strategy = BTEqualStrategyNumber;
+
+	/* Btree equality operator of specified opfamily */
+	operoid = get_opfamily_member(key->partopfamily[0],
+								  key->tcinfo->typid[0],
+								  key->tcinfo->typid[0],
+								  strategy);
+
+	/* lexpr */
+	if (key->partattrs[0] != 0)
+		key_col = (Node *) makeVar(1, key->partattrs[0],
+									key->tcinfo->typid[0],
+									key->tcinfo->typmod[0],
+									key->tcinfo->typcoll[0],
+									0);
+	else
+		key_col = (Node *) linitial(key->partexprs);
+
+	/* rexpr */
+	values_arr->array_typeid = get_array_type(key->tcinfo->typid[0]);
+	values_arr->array_collid = key->tcinfo->typcoll[0];
+	values_arr->element_typeid = key->tcinfo->typid[0];
+	values_arr->elements = values;
+	values_arr->multidims = false;
+	values_arr->location = -1;
+
+	/* build the actual predicate expression node */
+	arrayop_expr = makeNode(ScalarArrayOpExpr);
+	arrayop_expr->opno = operoid;
+	arrayop_expr->opfuncid = get_opcode(operoid);
+	arrayop_expr->useOr = true;
+	arrayop_expr->inputcollid = key->tcinfo->typcoll[0];
+	arrayop_expr->args = list_make2(key_col, values_arr);
+	arrayop_expr->location = -1;
+
+	return (Expr *) arrayop_expr;
+}
+
+/*
+ * get_check_expr_for_range
+ */
+static Expr *
+get_check_expr_for_range(PartitionKey key,
+						 List *lowervalues,
+						 bool lowerinc,
+						 List *uppervalues,
+						 bool upperinc)
+{
+	List	   *and_args = NIL;
+	ListCell   *cell1,
+			   *cell2,
+			   *partexprs_item;
+	int			i;
+	uint16		strategy;
+
+	/*
+	 * Handle the case with only one bound.
+	 *
+	 * In this case, consider only the first column of the key and generate
+	 * appropriate opclause since only the comparison with the first column
+	 * would have determined whether a rows went into such a partition.
+	 * It's always true that -INF < someval and someval < +INF.
+	 */
+	if (lowervalues == NIL || uppervalues == NIL)
+	{
+		List   *values;
+		Const  *key_val;
+		Node   *key_col;
+		Oid		operoid;
+		bool	islower,
+				inclusive;
+
+		if (lowervalues != NIL)
+		{
+			values = lowervalues;
+			islower = true;
+			inclusive = lowerinc;
+		}
+		else
+		{
+			values = uppervalues;
+			islower = false;
+			inclusive = upperinc;
+		}
+
+		/* lexpr */
+		if (key->partattrs[0] != 0)
+			key_col = (Node *) makeVar(1, key->partattrs[0],
+									  key->tcinfo->typid[0],
+									  key->tcinfo->typmod[0],
+									  key->tcinfo->typcoll[0],
+									  0);
+		else
+			key_col = (Node *) linitial(key->partexprs);
+
+		/* rexpr */
+		key_val = linitial(values);
+
+		if (islower)
+			strategy = inclusive ? BTGreaterEqualStrategyNumber : BTGreaterStrategyNumber;
+		else
+			strategy = inclusive ? BTLessEqualStrategyNumber : BTLessStrategyNumber;
+
+		operoid = get_opfamily_member(key->partopfamily[0],
+									  key->tcinfo->typid[0],
+									  key->tcinfo->typid[0],
+									  strategy);
+
+		and_args = lappend(and_args,
+							   make_opclause(operoid, BOOLOID,
+											 false,
+											 (Expr *) key_col,
+											 (Expr *) key_val,
+											 InvalidOid,
+											 key->tcinfo->typcoll[0]));
+
+		return makeBoolExpr(AND_EXPR, and_args, -1);
+	}
+
+	/* Both bounds constrain values going into the partition. */
+	i = 0;
+	partexprs_item = list_head(key->partexprs);
+	forboth (cell1, lowervalues, cell2, uppervalues)
+	{
+		Node   *key_col;
+		Const  *lower_val = lfirst(cell1);
+		Const  *upper_val = lfirst(cell2);
+		Expr   *lower_clause,
+			   *upper_clause;
+		Oid 	eqop,
+				lowerop,
+				upperop;
+		EState		   *estate;
+		MemoryContext	oldcxt;
+		Expr		   *test_expr;
+		ExprState	   *test_exprstate;
+		Datum			test_result;
+		bool 			isNull;
+
+		/* lexpr */
+		if (key->partattrs[i] != 0)
+		{
+			key_col = (Node *) makeVar(1, key->partattrs[i],
+									  key->tcinfo->typid[i],
+									  key->tcinfo->typmod[i],
+									  key->tcinfo->typcoll[i],
+									  0);
+		}
+		else
+		{
+			key_col = (Node *) lfirst(partexprs_item);
+			partexprs_item = lnext(partexprs_item);
+		}
+
+		/*
+		 * If lower_val = upper_val (= val, say), create a column = val
+		 * constraint.
+		 */
+		eqop = get_opfamily_member(key->partopfamily[i],
+								   key->tcinfo->typid[i],
+								   key->tcinfo->typid[i],
+								   BTEqualStrategyNumber);
+
+		estate = CreateExecutorState();
+		oldcxt = MemoryContextSwitchTo(estate->es_query_cxt);
+		test_expr = make_opclause(eqop,
+								  BOOLOID,
+								  false,
+								  (Expr *) lower_val,
+								  (Expr *) upper_val,
+								  InvalidOid,
+								  key->tcinfo->typcoll[i]);
+		fix_opfuncids((Node *) test_expr);
+		test_exprstate = ExecInitExpr(test_expr, NULL);
+		test_result = ExecEvalExprSwitchContext(test_exprstate,
+												GetPerTupleExprContext(estate),
+												&isNull, NULL);
+		MemoryContextSwitchTo(oldcxt);
+		FreeExecutorState(estate);
+
+		if (DatumGetBool(test_result))
+		{
+			and_args = lappend(and_args,
+								make_opclause(eqop,
+									  BOOLOID,
+									  false,
+									  (Expr *) key_col,
+									  /* could've been upper_val */
+									  (Expr *) lower_val,
+									  InvalidOid,
+									  key->tcinfo->typcoll[i]));
+
+			/* Go to the next column. */
+		}
+		else
+		{
+			/*
+			 * For all columns but last, use inclusive strategy (<= or >=).
+			 *
+			 * For the last column, the bound's inclusivity determines.
+			 */
+			strategy = i < key->partnatts - 1 || lowerinc
+									? BTGreaterEqualStrategyNumber
+									: BTGreaterStrategyNumber;
+			lowerop = get_opfamily_member(key->partopfamily[i],
+										  key->tcinfo->typid[i],
+										  key->tcinfo->typid[i],
+										  strategy);
+			strategy = i < key->partnatts - 1 || upperinc
+									? BTLessEqualStrategyNumber
+									: BTLessStrategyNumber;
+			upperop = get_opfamily_member(key->partopfamily[i],
+										  key->tcinfo->typid[i],
+										  key->tcinfo->typid[i],
+										  strategy);
+
+			lower_clause = make_opclause(lowerop,
+									  BOOLOID,
+									  false,
+									  (Expr *) key_col,
+									  (Expr *) lower_val,
+									  InvalidOid,
+									  key->tcinfo->typcoll[i]);
+			upper_clause = make_opclause(upperop,
+									  BOOLOID,
+									  false,
+									  (Expr *) key_col,
+									  (Expr *) upper_val,
+									  InvalidOid,
+									  key->tcinfo->typcoll[i]);
+
+			and_args = lappend(and_args,
+							   makeBoolExpr(AND_EXPR,
+								list_make2(lower_clause, upper_clause), -1));
+
+			/* No need to constraint further columns. */
+			break;
+		}
+
+		i++;
+	}
+
+	return makeBoolExpr(AND_EXPR, and_args, -1);
+}
+
+/*
+ * translate_var_attno
+ *		Changes Vars with a given attno in the provided expression tree to
+ *		Vars with new_attno
+ */
+static Node *
+translate_var_attno(Node *expr, AttrNumber attno, AttrNumber new_attno)
+{
+	translate_var_attno_mutator_context cxt;
+
+	cxt.old_attno = attno;
+	cxt.new_attno = new_attno;
+
+	return expression_tree_mutator(expr, translate_var_attno_mutator, &cxt);
+}
+
+/*
+ * translate_var_attno_mutator
+ */
+static Node *
+translate_var_attno_mutator(Node *node,
+							 translate_var_attno_mutator_context *cxt)
+{
+	if (node == NULL)
+		return NULL;
+
+	if (IsA(node, Var) && ((Var *) node)->varattno == cxt->old_attno)
+	{
+		Var		*newvar = copyObject(node);
+
+		newvar->varattno = cxt->new_attno;
+
+		return (Node *) newvar;
+	}
+
+	return expression_tree_mutator(node, translate_var_attno_mutator,
+								  (void *) cxt);
+}
+
+/*
+ * RelationGetPartitionConstraint
+ *		Returns the equivelent CHECK constraint expression for a partition
+ */
+Node *
+RelationGetPartitionCheckExpr(Relation rel)
+{
+	/* Quick exit */
+	if (!relid_is_partition(RelationGetRelid(rel)))
+		return NULL;
+
+	/* Quick copy */
+	if (rel->rd_partcheck)
+		return copyObject(rel->rd_partcheck);
+
+	/* None of those, generate */
+	return generate_partition_check_expr(rel);
+}
+
+/*
+ * generate_partition_constraints
+ *		Generate partition check constraint expression rel's pg_partition
+ *		entry
+ *
+ * Result expression tree is stored CacheMemoryContext to ensure it survives
+ * as long as the relcache entry. But we should be running in a less long-lived
+ * working context. To avoid leaking cache memory if this routine fails partway
+ * routine fails partway through, we build in working memory and then copy
+ * the completed structure into cache memory.
+ */
+static Node *
+generate_partition_check_expr(Relation rel)
+{
+	HeapTuple		tuple;
+	MemoryContext	oldcxt;
+	Datum		boundDatum;
+	bool		isnull;
+	Node	   *bound;
+	Node	   *my_expr = NULL,
+			   *result = NULL;
+	Oid			relid = RelationGetRelid(rel);
+	Relation	parent = heap_open(get_partition_parent(relid), NoLock);
+
+	/* quick copy */
+	if (rel->rd_partcheck)
+	{
+		heap_close(parent, NoLock);
+		return copyObject(rel->rd_partcheck);
+	}
+
+	tuple = SearchSysCache1(PARTRELID, relid);
+	Assert(HeapTupleIsValid(tuple));
+	boundDatum = SysCacheGetAttr(PARTRELID, tuple,
+								 Anum_pg_partition_partbound,
+								 &isnull);
+	Assert(!isnull);
+	bound = stringToNode(TextDatumGetCString(boundDatum));
+
+	my_expr = (Node *) get_check_expr_from_partbound(rel, parent, bound);
+
+	/*
+	 * If parent is also a partition, create a AND_EXPR BoolExpr with just
+	 * created expression and parent's check expression, as its args.
+	 */
+	if (relid_is_partition(RelationGetRelid(parent)))
+	{
+		Node	   *parent_expr;
+
+		parent_expr = generate_partition_check_expr(parent);
+		result = (Node *) makeBoolExpr(AND_EXPR,
+									   list_make2(parent_expr, my_expr), -1);
+	}
+	else
+		result = my_expr;
+
+	oldcxt = MemoryContextSwitchTo(CacheMemoryContext);
+	rel->rd_partcheck = copyObject(result);
+	MemoryContextSwitchTo(oldcxt);
+
+	ReleaseSysCache(tuple);
+	heap_close(parent, NoLock);
+
+	return result;
+}
+
+/*
+ * RelationGetPartitionDescNode
+ *		Recursively form partition node tree rooted at rel's node
+ */
+PartitionDescNode
+RelationGetPartitionDescNode(Relation rel)
+{
+	PartitionDescNode	root;
+
+	/*
+	 * Recurse to build the tree of partition descriptor nodes with
+	 * rel's descriptor as the root of the tree.
+	 */
+	root = GetPartitionDescNodeRecurse(rel, 0);
+	root->index = 0;
+	root->num_leaf_partitions = get_leaf_partition_count(root);
+
+	return root;
+}
+
+/*
+ * GetPartitionDescNodeRecurse
+ *		Workhorse of RelationGetPartitionDescNode
+ *
+ * offset is the index (0-based) of the first leaf node in the tree, as
+ * as determined and passed by the parent or the left sibling.
+ */
+static PartitionDescNode
+GetPartitionDescNodeRecurse(Relation rel, int offset)
+{
+	PartitionDescNode	root,
+						prev;
+	PartitionDesc		pdesc = RelationGetPartitionDesc(rel);
+	int					i;
+
+	/* First build our own node */
+	root = (PartitionDescNode) palloc0(sizeof(PartitionDescNodeData));
+	root->pdesc = pdesc;
+	root->relid = RelationGetRelid(rel);
+	root->offset = offset;
+	root->downlink = NULL;
+	root->next = NULL;
+
+	/*
+	 * Recursively add nodes for partitions that are themselves partitioned,
+	 * linking ourselves to the first such node via 'downlink'.  Each node
+	 * thus created (being on the same level) is linked to the right sibling
+	 * via 'next'.  For each node, determine the offset to pass and once
+	 * created, update its index and num_leaf_partitions.
+	 */
+	prev = NULL;
+	for (i = 0; i < pdesc->nparts; i++)
+	{
+		Oid			relid = pdesc->oids[i];
+		int			offset;
+		Relation	rel;
+		PartitionDescNode pdnode;
+
+		if (!relid_is_partitioned(relid))
+			continue;
+
+		rel = heap_open(relid, AccessShareLock);
+
+		/* Offset for the new node */
+		if (prev)
+			/*
+			 * Count leaves on the left - prev node has the account of those
+			 * on its own left and then there may have been some siblings
+			 * in-between that were leaves themselves.
+			 */
+			offset = prev->offset + prev->num_leaf_partitions +
+												(i - prev->index - 1);
+		else
+			/*
+			 * We're the first child - account of leaf nodes comes from the
+			 * parent.  Left siblings were all leaves themselves.
+			 */
+			offset = root->offset + i;
+
+		pdnode = GetPartitionDescNodeRecurse(rel, offset);
+		pdnode->index = i;
+		pdnode->num_leaf_partitions = get_leaf_partition_count(pdnode);
+
+		heap_close(rel, AccessShareLock);
+
+		/* Found our first child; link to it. */
+		if (root->downlink == NULL)
+			root->downlink = pdnode;
+
+		/* Link new node to the left sibling, if any  */
+		if (prev)
+			prev->next = pdnode;
+
+		prev = pdnode;
+	}
+
+	return root;
+}
+
+/*
+ * get_leaf_partition_count
+ * 		Recursively count the number of leaf partitions in the partition
+ *		tree rooted at pdnode
+ */
+static int
+get_leaf_partition_count(PartitionDescNode pdnode)
+{
+	int		i;
+	int 	result = 0;
+	PartitionDescNode node = pdnode->downlink;
+
+	for (i = 0; i < pdnode->pdesc->nparts; i++)
+	{
+		/* Indexes 0..(node->index - 1) are of leaf partitions */
+		if (node && i == node->index)
+		{
+			result += get_leaf_partition_count(node);
+			node = node->next;
+		}
+		else
+			result += 1;
+	}
+
+	return result;
+}
+
+/*
+ * get_leaf_partition_count
+ * 		Recursively compute the list of OIDs of leaf partitions in the
+ *		partition tree rooted at pdnode
+ */
+List *
+get_leaf_partition_oids(PartitionDescNode pdnode)
+{
+	int		i;
+	List   *result = NIL;
+	Oid	   *myparts = pdnode->pdesc->oids;
+	int		n_myparts = pdnode->pdesc->nparts;
+	PartitionDescNode node = pdnode->downlink;
+
+	for (i = 0; i < n_myparts; i++)
+	{
+		/* Indexes 0..(node->index - 1) are leaf partitions */
+		if (node && i == node->index)
+		{
+			result = list_concat(result, get_leaf_partition_oids(node));
+			node = node->next;
+		}
+		else
+			result = lappend_oid(result, myparts[i]);
+	}
+
+	return result;
+}
